version: '3'

services:
  zookeeper:
    image: confluentinc/cp-zookeeper:7.0.0
    hostname: zookeeper
    ports:
      - "2181:2181"
    environment:
      ZOOKEEPER_CLIENT_PORT: 2181
      ZOOKEEPER_TICK_TIME: 2000

  kafka:
    image: confluentinc/cp-kafka:7.0.0
    hostname: kafka
    volumes:
      - ./example:/topics-json
    depends_on:
      - zookeeper
    ports:
      - "29092:29092"
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_ZOOKEEPER_CONNECT: 'zookeeper:2181'
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: PLAINTEXT:PLAINTEXT,PLAINTEXT_HOST:PLAINTEXT
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://kafka:9092,PLAINTEXT_HOST://localhost:29092
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_GROUP_INITIAL_REBALANCE_DELAY_MS: 0
      KAFKA_TRANSACTION_STATE_LOG_MIN_ISR: 1
      KAFKA_TRANSACTION_STATE_LOG_REPLICATION_FACTOR: 1

  ksqldb-server:
    image: confluentinc/ksqldb-server:0.29.0
    hostname: ksqldb-server
    depends_on:
      - kafka
    ports:
      - "8088:8088"
    environment:
      KSQL_LISTENERS: http://0.0.0.0:8088
      KSQL_BOOTSTRAP_SERVERS: kafka:9092
      KSQL_KSQL_LOGGING_PROCESSING_STREAM_AUTO_CREATE: "true"
      KSQL_KSQL_LOGGING_PROCESSING_TOPIC_AUTO_CREATE: "true"

  ksqldb-cli:
    image: confluentinc/ksqldb-cli:0.29.0
    depends_on:
      - kafka
      - ksqldb-server
    entrypoint: /bin/sh
    tty: true

  ksqldb-init:
    build: ./ksqldb-init
    environment:
      KSQLDB_HOST: ksqldb-server:8088
      KAFKA_DEFAULT_TOPIC_PARTITIONS: 1
      DROP_IF_EXISTS: 'true'

  kafka-ui:
    image: provectuslabs/kafka-ui:latest
    ports:
      - "8080:8080"
    environment:
      KAFKA_CLUSTERS_0_NAME: local
      KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS: kafka:9092
      # KAFKA_CLUSTERS_0_ZOOKEEPER: zookeeper:2181
      KAFKA_CLUSTERS_0_KSQLDBSERVER: ksqldb-server:8088

  services-aggregator:
    build: ./services-aggregator
    # ports:
    #   - "5009:5009"
    # depends_on:
    #   - clickhouse-server
    #   - kafka
    environment:
      KSQLDB_SERVER: http://ksqldb-server:8088
      CLICKHOUSE_HOST: clickhouse-server
      CLICKHOUSE_USER: sdc
      CLICKHOUSE_SECRET: 123
      CLICKHOUSE_DB: sdc_analytics

#  first-availability-aggregator:
#    build: ./first-availability-aggregator
#    # ports:
#    #   - "5009:5009"
#    # depends_on:
#    #   - clickhouse-server
#    #   - kafka
#    environment:
#      PROMETHEUS_JOB_NAME: sdc_analytics_first_availability_aggregator
#      KAFKA_TOPIC: meetings
#      KAFKA_CONSUMER_GROUP_PREFIX: analytics-first-availability-aggregator
#      KAFKA_BOOTSTRAP_SERVERS: kafka:9092
#      CLICKHOUSE_HOST: clickhouse-server
#      CLICKHOUSE_USER: sdc
#      CLICKHOUSE_SECRET: 123
#      CLICKHOUSE_DB: sdc_analytics
#    deploy:
#      restart_policy:
#        condition: on-failure
#        delay: 5s
#        max_attempts: 10
#        window: 120s
#    healthcheck:
#      test: curl --fail http://0.0.0.0:8000/status || exit 1
#      interval: 5s
#      retries: 5
#      start_period: 20s
#      timeout: 10s
#
  charts-exporter:
    build: ./charts-exporter
    ports:
      - "8000:8000"
    environment:
      PROMETHEUS_JOB_NAME: analytics_charts_exporter
      CLICKHOUSE_HOST: clickhouse-server
      CLICKHOUSE_USER: sdc
      CLICKHOUSE_SECRET: 123
      CLICKHOUSE_DB: sdc_analytics
      MAX_DAYS: 180
      MAX_WEEKS: 52
      MAX_MONTHS: 18
      MAX_YEARS: 3
#    healthcheck:
#      test: curl --fail http://0.0.0.0:8000/healthcheck || exit 1
#      interval: 5s
#      retries: 5
#      start_period: 20s
#      timeout: 10s
#
#  kafka-meetings-producer:
#    build: ./kafka-meetings-producer
#    depends_on:
#      - kafka
#    deploy:
#      restart_policy:
#        condition: on-failure
#        delay: 5s
#        max_attempts: 10
#        window: 120s
#    environment:
#      KAFKA_TOPIC: meetings
#      KAFKA_BOOTSTRAP_SERVERS: kafka:9092
#
  clickhouse-server:
    build: ./clickhouse
    ports:
      - "8123:8123"
      - "9000:9000"
      - "9009:9009"
    volumes:
      - ./data:/var/lib/clickhouse
  # tabix:
  #   image: spoonest/clickhouse-tabix-web-client
  #   container_name: tabix
  #   ports:
  #     - "8080:80"
  #   environment:
  #     CH_HOST: localhost:8123
  #     USER: default
  #     CH_NAME: mouslim
  #     CH_LOGIN: default
  #     CH_PASSWORD: ''